from sympy import Symbol, symbols


class SymbolContainer(dict):
    """Singleton pattern http://es.wikipedia.org/wiki/Singleton#Python
    
    default symbols: a, b, c, d, m, n, x, y, z, 
    """

    _instance = None
    
    def __init__(self):
        syms = symbols('abcdmnxyz')
        assert isinstance(self._instance, dict)
        for s in syms:
            self._instance[str(s)] = s

    def __new__(cls, *args, **kargs): 
        if cls._instance is None:
            cls._instance = dict.__new__(cls)
        return cls._instance

    def reset(self):
        self.clear() #inherited
        return SymbolContainer()