from dsympy.parser import SympyExprParser
import py.test

def test_SympyParser_1():
    assert SympyExprParser('2*x').parse() == u'2*x'
    assert SympyExprParser('2 x').parse() == u'2*x'
    assert SympyExprParser('2  x').parse() == u'2*x'
    assert SympyExprParser('2^x').parse() == u'2**x'
    assert SympyExprParser('2 x + 1').parse() == u'2*x + 1'

def test_SympyParser_extract_symbols_1():
    assert SympyExprParser('2 x').extract_symbols() == [u'x']
    assert SympyExprParser('2 x + y').extract_symbols() == [u'x', u'y']
#    assert SympyExprParser('x y').extract_symbols() == [u'x', u'y']
#    assert SympyExprParser('x*y').extract_symbols() == [u'x', u'y']
    assert SympyExprParser('x * y').extract_symbols() == [u'x', u'y']
    assert SympyExprParser('log(x)').extract_symbols() == [u'x']
#    assert SympyExprParser('X*Y').extract_symbols() == [u'X', u'Y']

def test_SympyParser_extract_symbols_2():
    assert SympyExprParser('a_1 + a_2 + a_3').extract_symbols() == ['a_1', 'a_2', 'a_3']
    assert SympyExprParser('a_11 + a_21 + a_31').extract_symbols() == ['a_11', 'a_21', 'a_31']